import { extent, scaleLinear, scaleTime, line } from 'd3';
import { axes } from './axes';

export const lineChart = (
  selection,
  {
    data,
    width,
    height,
    xValue,
    yValue,
    margin,
    xAxisLabel,
    yAxisLabel,
  },
) => {
  const xScale = scaleTime()
    .domain(extent(data, xValue))
    .range([margin.left, width - margin.right]);

  const yScale = scaleLinear()
    .domain(extent(data, yValue))
    .range([height - margin.bottom, margin.top]);

  // selection
  //   .selectAll('circle')
  //   .data(data)
  //   .join('circle')
  //   .attr('cx', (d) => xScale(xValue(d)))
  //   .attr('cy', (d) => yScale(yValue(d)))
  //   .attr('r', 1);

  const lineGenerator = line()
    .x((d) => xScale(xValue(d)))
    .y((d) => yScale(yValue(d)));

  selection.call(axes, {
    xScale,
    yScale,
    xAxisLabel,
    yAxisLabel,
  });

  selection
    .selectAll('path#line-chart')
    .data([null])
    .join('path')
    .attr('id', 'line-chart')
    .attr('d', lineGenerator(data))
    .attr('stroke', 'black')
    .attr('fill', 'none');
};
